#!/bin/sh

RETVAL=0

umask 077

case "$1" in
  start)
	echo $"Starting bkcfg:---->"
	/sbin/bkcfg -r /tmp/config.tgz

	cd /tmp; tar zxvf config.tgz

	facinit=`cfg -a r sys.conf SYSTEM "factory"`
	echo "by firmware upgrade...factory" $facinit
	if [ "$facinit" = "1" ]; then
		# use  factory default settings after firmware upgrade
		echo "use factory default forced by firmware upgrade..."
		/etc/init.d/factory_reset.sh 
	fi

	#
	# create device nodes
	#
	mknod /dev/ptya0 c 2 176
	mknod /dev/ptya1 c 2 177
	mknod /dev/ttya0 c 3 176
	mknod /dev/ttya1 c 3 177

	mknod /dev/sda b 8 0
	mknod /dev/sda1 b 8 1
	mknod /dev/sda2 b 8 2
	mknod /dev/sda3 b 8 3
	mknod /dev/sda4 b 8 4
	mknod /dev/sdb b 8 16
	mknod /dev/sdb1 b 8 17
	mknod /dev/sdb2 b 8 18
	mknod /dev/sdb3 b 8 19
	mknod /dev/sdb4 b 8 20
	mknod /dev/sdc b 8 32
	mknod /dev/sdc1 b 8 33
	mknod /dev/sdc2 b 8 34
	mknod /dev/sdc3 b 8 35
	mknod /dev/sdc4 b 8 36
	mknod /dev/sdd b 8 48
	mknod /dev/sdd1 b 8 49
	mknod /dev/sdd2 b 8 50
	mknod /dev/sdd3 b 8 51
	mknod /dev/sdd4 b 8 52
	mknod /dev/sde b 8 64
	mknod /dev/sde1 b 8 65
	mknod /dev/sde2 b 8 66
	mknod /dev/sde3 b 8 67
	mknod /dev/sde4 b 8 68
	mknod /dev/sdf b 8 80
	mknod /dev/sdf1 b 8 81
	mknod /dev/sdf2 b 8 82
	mknod /dev/sdf3 b 8 83
	mknod /dev/sdf4 b 8 84
	mknod /dev/sdg b 8 96
	mknod /dev/sdg1 b 8 97
	mknod /dev/sdg2 b 8 98
	mknod /dev/sdg3 b 8 99
	mknod /dev/sdg4 b 8 100
	mknod /dev/sdh b 8 112
	mknod /dev/sdh1 b 8 113
	mknod /dev/sdh2 b 8 114
	mknod /dev/sdh3 b 8 115
	mknod /dev/sdh4 b 8 116

	mknod /dev/hwmon c 10 64
	mknod /dev/msgeng c 10 65

	mkdir /dev/pts
	mknod /dev/pts/0 c 136 0
	mknod /dev/pts/1 c 136 1
	mknod /dev/pts/2 c 136 2
	mknod /dev/ppp c 108 0
	# read mac address and set mac addr first
	macaddr=`cfg -a r net.conf NETWORK "mac addr"`
	macret=$?
	if [ $macret = 0 ]; then
		/sbin/ifconfig eth0 hw ether $macaddr
	fi
	
	# read date/time from RTC
	#/sbin/hwclock -s
	# set timezome
	/sbin/settz

	echo
	exit $RETVAL
	;;
  stop)
	echo $"Shutting down tmpfs: ---->"
	# donothing 
	echo	
        exit $RETVAL
	;;
esac
